<?php

/**
 * inf_lega_contra actions.
 *
 * @package    contratacion
 * @subpackage inf_lega_contra
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_lega_contraActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.no_contrato';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */



            /*
             * Variables opcionales
             */



            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            $whereContratista = "";
            $whereContrato = "";
            $whereSupervisor = "";
            $whereTipoContrato = "";
            $whereTipoConvenio = "";



            if (isset($request['id_contratista'])) {
                $whereContratista = " AND tab0.id_contratista=" . $request['id_contratista'];
            }

            if (isset($request['no_contrato'])) {
                $whereContrato = " AND tab0.no_contrato=" . $request['no_contrato'];
            }

            if (isset($request['id_supervisor'])) {
                $whereSupervisor = " AND tab0.id_supervisor=" . $request['id_supervisor'];
            }

            if (isset($request['id_tipo_contrato'])) {
                $whereTipoContrato = " AND tab0.id_tipo_contrato=" . $request['id_tipo_contrato'];
            }

            if (isset($request['id_tipo_convenio'])) {
                $whereTipoConvenio = " AND tab0.id_tipo_convenio=" . $request['id_tipo_convenio'];
            }


            /*
             * 
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select tab0.*

from(

select tab0.fecha_aprueba_poliza,tab0.fecha_inicio,tab0.fecha_terminacion, tab0.adjunto_contrato,tab0.fecha_liquidacion,tab0.adjunto_poliza,tab2.rp,tab2.fecha as fecha_rp,
tab1.fecha_contrato,tab1.no_contrato,tab1.id_contratista,tab1.id_supervisor,tab1.id_tipo_contrato,tab1.id_tipo_convenio,
tab1.id_anhos,tab1.tipo,tab1.DOC_CONTRA,tab1.nom_contra,tab1.completo_supervisor,tab1.valor

from co_legaliza_contrato tab0
join co_contrato_v tab1 ON tab1.ID_CONTRATO = tab0.ID_CONTRATO
left join RPS_V tab2 ON tab2.ID = tab0.id_rp


)tab0
where tab0.FECHA_CONTRATO between to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')

$whereContratista
$whereContrato
$whereSupervisor
$whereTipoContrato
$whereTipoConvenio

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.*

from(

select tab0.fecha_aprueba_poliza,tab0.fecha_inicio,tab0.fecha_terminacion, tab0.adjunto_contrato,tab0.fecha_liquidacion,tab0.adjunto_poliza,tab2.rp,tab2.fecha as fecha_rp,
tab1.fecha_contrato,tab1.no_contrato,tab1.id_contratista,tab1.id_supervisor,tab1.id_tipo_contrato,tab1.id_tipo_convenio,
tab1.id_anhos,tab1.tipo,tab1.DOC_CONTRA,tab1.nom_contra,tab1.completo_supervisor,tab1.valor

from co_legaliza_contrato tab0
join co_contrato_v tab1 ON tab1.ID_CONTRATO = tab0.ID_CONTRATO
left join RPS_V tab2 ON tab2.ID = tab0.id_rp


)tab0
where tab0.FECHA_CONTRATO between to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')

$whereContratista
$whereContrato
$whereSupervisor
$whereTipoContrato
$whereTipoConvenio
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_lega_contra] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }
}
